import 'package:flutter_test/flutter_test.dart';
import 'package:kayta_package/util/util.dart';

void main() {
  test('CPF remove caracteres', () {
    final data = '111.222.333-44';
    expect(Util.removeCaracteres(data), '11122233344');
  });

  test('CNPJ remove caracteres', () {
    final data = '11.222.333/4444-55';
    expect(Util.removeCaracteres(data), '11222333444455');
  });

  test('CEP remove caracteres', () {
    final data = '11222-333';
    expect(Util.removeCaracteres(data), '11222333');
  });

  test('REAL remove caracteres', () {
    final data = '11.222';
    expect(Util.removeCaracteres(data), '11222');
  });

  test('CENTAVOS remove caracteres', () {
    final data = '0,99';
    expect(Util.removeCaracteres(data), '099');
  });

  test('TELEFONE remove caracteres', () {
    final data = '(99) 88888-7777';

    expect(Util.removeCaracteres(data), '99888887777');
  });
}
